#include <stdio.h>
#include "Types.h"


static void Fix(char *fn)
{
 FILE *fp;
 unsigned long month,day,year;
 long play;
 long fade;
 char artist[32];
 unsigned char disabled;
 unsigned char emulator;
 char buf[256];
 char *comp="SNES-SPC700 Sound File Data";
 int x;

 fp=fopen(fn,"r+");
 if(fread(buf,1,strlen(comp),fp)!=strlen(comp))
  return;
 if(memcmp(buf,comp,strlen(comp))) return;

 fseek(fp,0x9E,SEEK_SET);
 fread(buf,1,11,fp);
 buf[10]=0;
 sscanf(buf,"%ld/%ld/%ld",&month,&day,&year);

 fread(buf,1,3,fp);
 buf[4]=0;
 play=atoi(buf);
 fread(buf,1,5,fp);
 buf[6]=0;
 fade=atoi(buf);
 
 fread(artist,1,32,fp);
 disabled=fgetc(fp);
 emulator=fgetc(fp);

 fseek(fp,0x9E,SEEK_SET);

 fputc(year,fp);
 fputc(year>>8,fp);
 fputc(month,fp);
 fputc(day,fp);

 for(x=0;x<7;x++) fputc(0,fp);

 fputc(play,fp);
 fputc(play>>8,fp);
 fputc(play>>16,fp);
 fputc(fade ,fp);
 fputc(fade>>8,fp);
 fputc(fade>>16,fp);
 fputc(fade>>24,fp);
 fwrite(artist,1,32,fp);
 fputc(disabled,fp);
 fputc(emulator,fp);
 for(x=0;x<46;x++) fputc(0,fp);
}

main(int argc, char *argv[])
{
 int x=1;

 if(argc<=1)
 {
  puts("Need arguments!");
  return;
 }
 while(x<argc)
 {
  printf("Converting %s: ",argv[x]);
  Fix(argv[x]);
  putchar('\n');
  x++;
 }
}
